/*
								+--------------------------------+
								|                                |
								| *** Portable integer types *** |
								|                                |
								|  Copyright  -tHE SWINe- 2008  |
								|                                |
								|            Integer.h           |
								|                                |
								+--------------------------------+
*/

#ifndef __INTEGER_TYPES_INCLUDED
#define __INTEGER_TYPES_INCLUDED

#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
	#include <inttypes.h>
#elif defined(__sun__)
	#include <inttypes.h>
	#if defined(__STDC__)
		typedef char int8_t;
		typedef unsigned char uint8_t;
		typedef short int16_t;
		typedef unsigned short uint16_t;
		typedef int int32_t;
		typedef unsigned int uint32_t;
		#if defined(__arch64__)
			typedef long int64_t;
			typedef unsigned long uint64_t;
		#else
			typedef long long int int64_t;
			typedef unsigned long long int uint64_t;
		#endif /* __arch64__ */
	#endif /* __STDC__ */
#elif defined( __VMS )
	#include <inttypes.h>
#elif defined(__SCO__) || defined(__USLC__)
	#include <stdint.h>
#elif defined(__UNIXOS2__) || defined(__SOL64__)
	typedef char int8_t;
	typedef unsigned char uint8_t;
	typedef short int16_t;
	typedef unsigned short uint16_t;
	typedef long int int32_t;
	typedef unsigned long int uint32_t;
	typedef long long int int64_t;
	typedef unsigned long long int uint64_t;
#elif defined(_WIN32) && defined(__GNUC__) // MinGW
	#include <stdint.h>
#elif defined(_WIN32) // MSVC
	typedef __int8 int8_t;
	typedef __int16 int16_t;
	typedef __int32 int32_t;
	typedef __int64 int64_t;
	typedef unsigned __int8 uint8_t;
	typedef unsigned __int16 uint16_t;
	typedef unsigned __int32 uint32_t;
	typedef unsigned __int64 uint64_t;
#else // fallback
	#include <inttypes.h>
#endif
// define int types

#ifndef UINT8_MAX
#define UINT8_MAX  (uint8_t(-1))
#endif
#ifndef UINT16_MAX
#define UINT16_MAX (uint16_t(-1))
#endif
#ifndef UINT32_MAX
#define UINT32_MAX (uint32_t(-1))
#endif
#ifndef UINT64_MAX
#define UINT64_MAX (uint64_t(-1))
#endif
#ifndef INT8_MAX
#define INT8_MAX  (int8_t(UINT8_MAX / 2))
#endif
#ifndef INT16_MAX
#define INT16_MAX (int16_t(UINT16_MAX / 2))
#endif
#ifndef INT32_MAX
#define INT32_MAX (int32_t(UINT32_MAX / 2))
#endif
#ifndef INT64_MAX
#define INT64_MAX (int64_t(UINT64_MAX / 2))
#endif
#ifndef INT8_MIN
#define INT8_MIN  (int8_t(-INT8_MAX - 1))
#endif
#ifndef INT16_MIN
#define INT16_MIN (int16_t(-INT16_MAX - 1))
#endif
#ifndef INT32_MIN
#define INT32_MIN (int32_t(-INT32_MAX - 1))
#endif
#ifndef INT64_MIN
#define INT64_MIN (int64_t(-INT64_MAX - 1))
#endif
// calc limits

#endif //__INTEGER_TYPES_INCLUDED
